import getCrc from './getCrc';
import int32Mul from './int32Mul';

export default function decryptFile(dv: DataView, length: number, [key0, key1, key2]: [number, number, number]) {
  for (let j = 0; j < length; j += 1) {
      let testChar = dv.getUint8(j);
      const keyPart = (key2 | 2) & 0xFFFF;
      const decryptedByte = (keyPart * (keyPart ^ 1)) >>> 8;
      testChar ^= decryptedByte & 0xFF;
      key0 = getCrc(key0, testChar);
      key1 = ((int32Mul(((key1 + (key0 & 0xFF)) >>> 0), 134775813) >>> 0) + 1) >>> 0;
      key2 = getCrc(key2, key1 >>> 24);
      dv.setUint8(j, testChar);
  }
  //if it was decrypted, we skip the first 12 bytes (random encryption header)
  return new DataView(dv.buffer, 12);
}
