export default class ByteReader {
  private dvArray: DataView[];
  private dvIndex = 0;
  private pos = 0;
  constructor(dvArray: DataView[], startDvIndex: number, offset: number) {
    this.dvArray = dvArray;
    this.dvIndex = startDvIndex;
    this.pos = offset;
  }
  public readByte() {
    const curByte = this.dvArray[this.dvIndex].getUint8(this.pos);
    this.pos += 1;
    if (this.pos >= this.dvArray[this.dvIndex].byteLength) {
      this.pos = 0;
      this.dvIndex += 1;
      if (this.dvIndex >= this.dvArray.length) { throw new Error('Tried to read beyond DataView boundary in extractFile'); }
    }
    return curByte;
  }
  public seek(num: number) {
    this.pos += num;
    if (this.pos >= this.dvArray[this.dvIndex].byteLength) {
      this.pos -= this.dvArray[this.dvIndex].byteLength;
      this.dvIndex += 1;
      if (this.dvIndex >= this.dvArray.length) { throw new Error('Tried to read beyond DataView boundary in extractFile'); }
    }
  }
  public extractDv(length: number) {
    const dv = new DataView(new ArrayBuffer(length));
    for (let i = 0; i < length; i += 1) {
        dv.setUint8(i, this.readByte()); //TODO: refactor this so it is more optimized
    }
    return dv;
  }
}
